### olive

dat=read.table("olive.txt",sep=",")
Y=c("Southern Italy","   Sardinia","Northern Italy")
Y2=c("Southern Italy","Sardinia","Northern Italy")
dat=cbind(dat,region=Y[dat$Region])
dat[,4:11]=dat[,4:11]/100


mycol=c("red","blue","green")

attach(dat)

postscript("rpart.olive.1.ps")
par(las=1)
plot(eicosenoic,linoleic,type="n")
points(eicosenoic,linoleic,col=mycol[Region],cex=0.7,pch=15)
legend(0.475,14.20,Y2,col=mycol,pch=rep(15,3))
dev.off()

postscript("rpart.olive.2.ps")
par(las=1)
plot(eicosenoic,linoleic,type="n")
points(eicosenoic,linoleic,col=mycol[Region],cex=0.7,pch=15)
abline(v=0.07)
legend(0.475,14.20,Y2,col=mycol,pch=rep(15,3))
dev.off()

postscript("rpart.olive.3.ps")
par(las=1)
plot(eicosenoic,linoleic,type="n")
points(eicosenoic,linoleic,col=mycol[Region],cex=0.7,pch=15)
abline(v=0.07)
lines(c(-0.10,0.07),rep(10.535,2))
legend(0.475,14.20,Y2,col=mycol,pch=rep(15,3))
dev.off()

detach(dat)

rpart1=rpart(region~linoleic+eicosenoic,data=dat)

postscript("rpart.olive.tree1.ps")
plot(rpart1,uniform=T,branch=1,compress=T,margin=0.1)
text(rpart1,all=F,use.n=T,fancy=F)
dev.off()


### iris

data(iris)
nms=unique(iris$Species)
mycol=c("red","blue","green")

postscript("rpart.iris.1.ps")
par(las=1,xaxs="i",yaxs="i")
plot(c(0.9,7),c(0,2.6),xlab="petal length",ylab="petal width",type="n")
for(j in 1:3){
points(subset(iris,Species==nms[j])[,3:4],col=mycol[j],cex=0.9,pch=15)}
#for(j in 1:3){
#points(subset(iris,Species==nms[j])[,3:4],cex=0.9,pch=0)}
legend(1,2.5,levels(nms),col=mycol,pch=rep(15,3))
dev.off()

postscript("rpart.iris.2.ps")
par(las=1,xaxs="i",yaxs="i")
plot(c(0.9,7),c(0,2.6),xlab="petal length",ylab="petal width",type="n")
for(j in 1:3){
points(subset(iris,Species==nms[j])[,3:4],col=mycol[j],cex=0.9,pch=15)}
#for(j in 1:3){
#points(subset(iris,Species==nms[j])[,3:4],cex=0.9,pch=0)}
legend(1,2.5,levels(nms),col=mycol,pch=rep(15,3))
abline(v=2.45)
lines(c(2.45,8),rep(1.75,2))
lines(rep(4.95,2),c(0,1.75))
dev.off()

postscript("rpart.iris.3.ps")
par(las=1,xaxs="i",yaxs="i")
plot(c(0.9,7),c(0,2.6),xlab="petal length",ylab="petal width",type="n")
abline(v=2.45)
lines(c(2.45,8),rep(1.75,2))
lines(rep(4.95,2),c(0,1.75))
polygon(c(0.9,2.45,2.45,0.9),c(0,0,2.6,2.6),col="lightpink")
polygon(c(2.45,4.95,4.95,2.45),c(0,0,1.75,1.75),col="lightblue")
polygon(c(4.95,7,7,4.95),c(0,0,1.75,1.75),col="palegreen")
polygon(c(2.45,7,7,2.45),c(1.75,1.75,2.6,2.6),col="palegreen")
for(j in 1:3){
points(subset(iris,Species==nms[j])[,3:4],col=mycol[j],cex=0.7,pch=15)}
for(j in 1:3){
points(subset(iris,Species==nms[j])[,3:4],cex=0.9,pch=0)}
legend(1,2.5,levels(nms),col=mycol,pch=rep(15,3))
dev.off()


temp=rpart.control(cp=0,minsplit=8)
rpart.iris=rpart(Species~Petal.Length+Petal.Width,data=iris,control=temp)

postscript("rpart.iris.tree1.ps")
plot(rpart.iris,uniform=T,branch=1,compress=T,margin=0.1)
text(rpart.iris,all=F,use.n=T,fancy=F)
dev.off()



### birthweight

library(MASS)
data(birthwt)
birthwt$smoke <- factor(birthwt$smoke,levels=0:1,labels=c("no","yes"))
birthwt$race <- factor(birthwt$race,levels=1:3,labels=c("white","black","other"))
birthwt$ht <- factor(birthwt$ht,levels=0:1,labels=c("absent","present"))
birthwt$ui <- factor(birthwt$ui,levels=0:1,labels=c("absent","present"))
birthwt$low <- factor(birthwt$low,levels=0:1,labels=c("high","low"))


install.packages("tree")
library(tree)

bwt.tree=tree(bwt~age+lwt+race+smoke+ptl+ht+ui+ftv,data=bwt.dat)
bwt.tree=tree(bwt~.-low,data=bwt.dat)

bwt.tree2 <- tree(bwt~race+smoke,data=bwt.dat)

# tree info
summary(bwt.tree)
print(bwt.tree)

# plot the tree
plot(bwt.tree)
text(bwt.tree)

# Splus command
post.tree(bwt.tree)

# two choices how to plot the tree
plot(bwt.tree)
plot(bwt.tree,type="u")

# model selection 
bwt.cv <- cv.tree(bwt.tree)
# R uses pruning as default
# Splus uses shrinking as default
# pruning in Splus
bwt.cv <- cv.tree(bwt.tree,,prune.tree)
# or
bwt.cv <- cv.tree(bwt.tree,FUN=prune.tree)

# size versus deviance
plot(prune.tree(bwt.tree))

# cross-validated scores 
# (differences for pruning and shrinking)
plot(bwt.cv)

# pick the best tree from the above plot
bwt.tree.b <- prune.tree(bwt.tree,best=5)
plot(bwt.tree.b)
text(bwt.tree.b)




### kyphosis


data(kyphosis)

temp=rpart.control(cp=0,minsplit=5)
kyph.rpart=rpart(Kyphosis~Age+Number+Start,data=kyphosis,control=temp)

kyph.rpart=rpart(Kyphosis~Age+Number+Start,data=kyphosis,control=rpart.control(cp=0,minsplit=5))

postscript("rpart.kyph.tree1.ps")
plot(kyph.rpart,uniform=T,branch=1,compress=T,margin=0.1)
text(kyph.rpart,all=F,use.n=T,fancy=F)
dev.off()

kyph.tree=tree(Kyphosis~Age+Number+Start,data=kyphosis)

postscript("tree.kyph.dev.ps")
plot(kyph.tree)
text(kyph.tree)
dev.off()

postscript("tree.kyph.all.ps")
par(mfrow=c(2,2))
plot(kyph.tree)
text(kyph.tree,cex=0.7)
plot(prune.tree(kyph.tree))
plot(kyph.tree)
plot(kyph.tree,type="u")
dev.off()






temp=rpart.control(cp=0,minsplit=5)
kyph.rpart=rpart(Kyphosis~Age+Number+Start,data=kyphosis,control=temp)
plotcp(kyph.rpart)
printcp(kyph.rpart)

kyph.rpart=rpart(Kyphosis~Age+Number+Start,data=kyphosis)
plotcp(kyph.rpart)
printcp(kyph.rpart)


plot(prune.tree(kyph.tree))


# make fancy postscript plot
post.tree(kyph.tree)

# tree info
summary(kyph.tree)
print(kyph.tree)







data(kyphosis)
fit=rpart(Kyphosis~Age+Number+Start,data=kyphosis)
plot(fit);text(fit)

kyph.tree=tree(Kyphosis~Age+Number+Start,data=kyphosis)
plot(kyph.tree)
text(kyph.tree)

kyph.tree.cv=cv.tree(kyph.tree)
plot(kyph.tree.cv)

kyph.tree.final=prune.tree(kyph.tree,best=3)
plot(kyph.tree.final)
text(kyph.tree.final)

post(kyph.tree.final)

fit=rpart(Kyphosis~Age+Number+Start,data=kyphosis)
plot(fit);text(fit)

post(fit)

printcp(fit)



### breast cancer

library(MASS)
biopsy

rpart2=rpart(class~V5+V6,data=biopsy)
plot(rpart2);text(rpart2)


    'ID' Sample code number (not unique)

     'V1' Clump thickness

     'V2' Uniformity of cell size

     'V3' Uniformity of cell shape

     'V4' Marginal adhesion

     'V5' Single epithelial cell size

     'V6' Bare nuclei (16 values are missing)

     'V7' Bland chromatin




rpart2=rpart(class~V1+V2+V3+V4+V5+V6+V7,data=biopsy)
plot(rpart2);text(rpart2)

mybiopsy=biopsy[,c(11,2,7)]
names(mybiopsy)[2:3]=c("size","bncl")

rpart2=rpart(class~size+bncl,data=mybiopsy)
plot(rpart2);text(rpart2)


rpart2=rpart(class~.,data=biopsy)
plot(rpart2);text(rpart2)

tree2=tree(class~.,data=biopsy)
plot(rpart2);text(rpart2)


### birthweight

library(MASS)
data(birthwt)
birthwt$smoke <- factor(birthwt$smoke,levels=0:1,labels=c("no","yes"))
birthwt$race <- factor(birthwt$race,levels=1:3,labels=c("white","black","other"))
birthwt$ht <- factor(birthwt$ht,levels=0:1,labels=c("absent","present"))
birthwt$ui <- factor(birthwt$ui,levels=0:1,labels=c("absent","present"))
birthwt$low <- factor(birthwt$low,levels=0:1,labels=c("high","low"))

bwt.rpart=rpart(bwt~age+lwt+race+smoke+ptl+ht+ui+ftv,data=birthwt)
bwt.rpart=rpart(bwt~.,data=birthwt[,-1])
plot(bwt.rpart)
text(bwt.rpart)


library(rpart)
rpart.bwt=rpart(bwt~age+lwt+race+smoke+ptl+ht+ui+ftv,data=birthwt)
rpart.bwt=rpart(bwt~.,data=birthwt[,-1])
postscript("rpart.bwt.tree1.ps")
plot(rpart.bwt,uniform=T,branch=1,compress=T,margin=0.1)
text(rpart.bwt,all=F,use.n=T,fancy=F)
dev.off()
post(rpart.bwt,title="")

print(rpart.bwt)

printcp(rpart.bwt)

postscript("rpart.bwt.cp.ps")
plotcp(rpart.bwt)
dev.off()

postscript("rpart.bwt.cp.2.ps")
par(mfrow=c(3,3))
for(j in 1:9){
plotcp(rpart(bwt~.,data=birthwt[,-1]))}
dev.off()


rpart.bwt2=rpart(bwt~.,data=birthwt[,-1],cp=0.06)
postscript("rpart.bwt.tree2.ps")
plot(rpart.bwt2,uniform=T,branch=1,compress=T,margin=0.1)
text(rpart.bwt2,all=F,use.n=T,fancy=F)
dev.off()





par(mfrow=c(1,1))
post(bwt.rpart.2)



post(bwt.rpart)

print(bwt.rpart)

printcp(bwt.rpart)

postscript("bwt.rpart.cp.ps")
plotcp(bwt.rpart)
dev.off()

postscript("bwt.rpart.cp.2.ps")
par(mfrow=c(3,3))
for(j in 1:9){
plotcp(rpart(bwt~.,data=birthwt[,-1]))}
dev.off()

bwt.rpart.2=rpart(bwt~.,data=birthwt[,-1],cp=0.06)
par(mfrow=c(1,1))
post(bwt.rpart.2)










bwt.dat <- read.table("lbw.dat",header=T)
bwt.dat$smoke <- factor(bwt.dat$smoke,levels=0:1,labels=c("no","yes"))
bwt.dat$race <- factor(bwt.dat$race,levels=1:3,
                       labels=c("white","black","other"))
bwt.dat$ht <- factor(bwt.dat$ht,levels=0:1,labels=c("absent","present"))
bwt.dat$ui <- factor(bwt.dat$ui,levels=0:1,labels=c("absent","present"))
bwt.dat$low <- factor(bwt.dat$low,levels=0:1,labels=c("high","low"))

bwt.rpart1=rpart(low~age+lwt+race+smoke+ptl+ht+ui+ftv,data=bwt.dat)
bwt.rpart1=rpart(low~.,data=bwt.dat[,-10])

bwt.rpart1=rpart(low~.,data=bwt.dat[,-10],cp=0.0000001)
post(bwt.rpart1)

printcp(bwt.rpart1)

par(mfrow=c(3,3))
for(j in 1:9){
bwt.rpart1=rpart(low~.,data=bwt.dat[,-10])
plotcp(bwt.rpart1)}


bwt.rpart=rpart(bwt~age+lwt+race+smoke+ptl+ht+ui+ftv,data=bwt.dat)
bwt.rpart=rpart(bwt~.,data=bwt.dat[,-1])

post(bwt.rpart)
printcp(bwt.rpart)
plotcp(bwt.rpart)


par(mfrow=c(3,3))
for(j in 1:9){
bwt.rpart2=rpart(bwt~.,data=bwt.dat[,-1])
plotcp(bwt.rpart2)}


par(mfrow=c(1,1))
bwt.rpart2=rpart(bwt~.,data=bwt.dat[,-1],cp=0.06)
post(bwt.rpart2)



###

# -> CRAP
library(MASS)
data(birthwt)
mybwt=birthwt[,c(3,8,10)]
summary(mybwt)

lm1=lm(bwt~ui+lwt,data=mybwt)
summary(lm1)

x=seq(80,250,10)
y=c(0,1)
xy=expand.grid(seq(80,250,10),c(0,1))
newdat=data.frame(cbind(lwt=xy[,1],ui=xy[,2],bwt=0))
z=matrix(predict(lm1,newdat),ncol=2)

trans3d=function(x,y,z,pmat){
  tr=cbind(x,y,z,1) %*% pmat
  list(x = tr[,1]/tr[,4], y= tr[,2]/tr[,4])}


persp(x,y,z,theta=0,phi=30,expand=0.8,col="lightblue",
xlab="mother's weight",ylab="uterine irritability",zlab="birth weight",
zlim=range(mybwt[,3])) -> theplot
points(trans3d(mybwt[,1],mybwt[,2],mybwt[,3],theplot),col=2,pch=16)


# simulated data

#a
x1=runif(50)
x2=runif(50)
y1=5+x1+1.5*x2+0.1*rnorm(50)
mydat1=data.frame(y1=y1,x1=x1,x2=x2)
lm1=lm(y1~x1+x2,data=mydat1)

x=seq(0,1,0.05)
y=seq(0,1,0.05)
xy=expand.grid(x,y)
newdat=data.frame(y1=0,x1=xy[,1],x2=xy[,2])
z1=matrix(predict(lm1,newdat),ncol=21)
z1b=predict(lm1)

persp(x,y,z1,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="x",ylab="y",zlab="z",
zlim=range(c(mydat1$y1,z1,z1b,z2,z2b))) -> theplot
for(j in 1:50){
aa=trans3d(mydat1[j,2],mydat1[j,3],mydat1[j,1],theplot)
bb=trans3d(mydat1[j,2],mydat1[j,3],z1b[j],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)
points(aa,col="red",pch=16)
points(bb,col="green",pch=16)}

tree1=tree(y1~x1+x2,data=mydat1)
plot(tree1);text(tree1)
tree1.cv=cv.tree(tree1)
plot(tree1.cv)
tree2=prune.tree(tree1,best=3)
plot(tree2);text(tree2)
z2=matrix(predict(tree2,newdat),ncol=21)
z2b=predict(tree2)

persp(x,y,z2,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="x",ylab="y",zlab="z",
zlim=range(c(mydat1$y1,z1,z1b,z2,z2b))) -> theplot
for(j in 1:50){
aa=trans3d(mydat1[j,2],mydat1[j,3],mydat1[j,1],theplot)
bb=trans3d(mydat1[j,2],mydat1[j,3],z2b[j],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)
points(aa,col="red",pch=16)
points(bb,col="green",pch=16)}

#b
y2=rep(5,50)+0.25*rnorm(50)
wh1=(1:50)[x1<0.5]
wh2=(1:50)[(x1>=0.5)&(x2<0.5)]
y2[wh1]=y2[wh1]+2
y2[wh2]=y2[wh2]-2
mydat2=data.frame(y2=y2,x1=x1,x2=x2)
lm2=lm(y2~x1+x2,data=mydat2)

newdat2=data.frame(y2=0,x1=xy[,1],x2=xy[,2])
z3=matrix(predict(lm2,newdat2),ncol=21)
z3b=predict(lm2)

persp(x,y,z3,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="x",ylab="y",zlab="z",
zlim=range(c(mydat2$y2,z3,z3b,z4,z4b))) -> theplot
points(trans3d(mydat2[,2],mydat2[,3],mydat2[,1],theplot),col=2,pch=16)
for(j in 1:50){
aa=trans3d(mydat2[j,2],mydat2[j,3],mydat2[j,1],theplot)
bb=trans3d(mydat2[j,2],mydat2[j,3],z3b[j],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)
points(aa,col="red",pch=16)
points(bb,col="green",pch=16)}

tree3=tree(y2~x1+x2,data=mydat2)
tree4=prune.tree(tree3,best=3)
plot(tree4);text(tree4)
z4=matrix(predict(tree4,newdat2),ncol=21)
z4b=predict(tree4)

persp(x,y,z4,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="x",ylab="y",zlab="z",
zlim=range(c(mydat2$y2,z3,z3b,z4,z4b))) -> theplot
points(trans3d(mydat2[,2],mydat2[,3],mydat2[,1],theplot),col=2,pch=16)
for(j in 1:50){
aa=trans3d(mydat2[j,2],mydat2[j,3],mydat2[j,1],theplot)
bb=trans3d(mydat2[j,2],mydat2[j,3],z4b[j],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)
points(aa,col="red",pch=16)
points(bb,col="green",pch=16)}


postscript("foof.cart.lm.ps")

par(mfrow=c(2,2),mar=rep(2,4))

persp(x,y,z1,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="x",ylab="y",zlab="z",
zlim=range(c(mydat1$y1,z1,z1b,z2,z2b))) -> theplot
for(j in 1:50){
aa=trans3d(mydat1[j,2],mydat1[j,3],mydat1[j,1],theplot)
bb=trans3d(mydat1[j,2],mydat1[j,3],z1b[j],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)
points(aa,col="red",pch=16)
points(bb,col="green",pch=16)}

persp(x,y,z2,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="x",ylab="y",zlab="z",
zlim=range(c(mydat1$y1,z1,z1b,z2,z2b))) -> theplot
for(j in 1:50){
aa=trans3d(mydat1[j,2],mydat1[j,3],mydat1[j,1],theplot)
bb=trans3d(mydat1[j,2],mydat1[j,3],z2b[j],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)
points(aa,col="red",pch=16)
points(bb,col="green",pch=16)}

persp(x,y,z3,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="x",ylab="y",zlab="z",
zlim=range(c(mydat2$y2,z3,z3b,z4,z4b))) -> theplot
points(trans3d(mydat2[,2],mydat2[,3],mydat2[,1],theplot),col=2,pch=16)
for(j in 1:50){
aa=trans3d(mydat2[j,2],mydat2[j,3],mydat2[j,1],theplot)
bb=trans3d(mydat2[j,2],mydat2[j,3],z3b[j],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)
points(aa,col="red",pch=16)
points(bb,col="green",pch=16)}

persp(x,y,z4,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="x",ylab="y",zlab="z",
zlim=range(c(mydat2$y2,z3,z3b,z4,z4b))) -> theplot
points(trans3d(mydat2[,2],mydat2[,3],mydat2[,1],theplot),col=2,pch=16)
for(j in 1:50){
aa=trans3d(mydat2[j,2],mydat2[j,3],mydat2[j,1],theplot)
bb=trans3d(mydat2[j,2],mydat2[j,3],z4b[j],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)
points(aa,col="red",pch=16)
points(bb,col="green",pch=16)}

dev.off()
















persp(x,y,z3,theta=30,phi=30,expand=0.8,col="lightblue",
xlab="x",ylab="y",zlab="z",
zlim=range(mydat2$y2)) -> theplot
for(j in 1:50){
aa=trans3d(mydat2[j,2],mydat2[j,3],mydat2[j,1],theplot)
bb=trans3d(mydat2[j,2],mydat2[j,3],z3b[j],theplot)
lines(c(aa$x,bb$x),c(aa$y,bb$y),lwd=2)
points(aa,col="red",pch=16)
points(bb,col="green",pch=16)}







points(aa,col="red",pch=16)
points(bb,col="green",pch=16)


lines(c(aa$x,bb$x),c(aa$y,bb$y))


#points(trans3d(mydat2[,2],mydat2[,3],mydat2[,1],theplot),col=2,pch=16)
#points(trans3d(mydat2[,2],mydat2[,3],z3b,theplot),col="yellow",pch=16)



aa=trans3d(mydat2[j,2],mydat2[j,3],mydat2[j,1],theplot)
bb=trans3d(mydat2[j,2],mydat2[j,3],z3b[j],theplot)



for(j in 1:1){
lines(
trans3d(mydat2[j,2],mydat2[j,3],mydat2[j,1],theplot),
trans3d(mydat2[j,2],mydat2[j,3],z3b[j],theplot),
lwd=2)}




points(trans3d(mydat2[1,2],mydat2[1,3],mydat2[1,1],theplot),col="green",pch=16)
points(trans3d(mydat2[1,2],mydat2[1,3],z3b[1],theplot),col="yellow",pch=16)



lines(trans3d(xr, yr, f(xr, yr), res), col = "pink", 
    lwd = 2)

